public with sharing class CPGCategoryLogic {    
    static  List<string> lstExpression=new List<string>();
    static list<Data_Set_Column_Detail__c> lstColumns = new list<Data_Set_Column_Detail__c>();
    static integer expressionSequence=1;
    
    
    @AuraEnabled
    public static String[] getDataOptions(string colDataType){            
        return getOperators(colDataType);
    }
    
    public static String[] getOperators(string oprtype){
        String[] strOperator= new String[]{};            
            list<CategoryPostgresOperands__mdt> lstMetaData = [select PostgresOperands__c, SalesforceOperands__c,
                                                               sequence__c, datatype__c
                                                               from CategoryPostgresOperands__mdt                                                                
                                                               order by sequence__c]; 
        if(lstMetaData!= null && lstMetaData.size()>0){
            for(CategoryPostgresOperands__mdt operands : lstMetaData){
                String dataOper = operands.SalesforceOperands__c.replace('_',' ');                
                if(oprtype=='Text'){
                    if(operands.datatype__c=='Text' || operands.datatype__c.equalsIgnoreCase('TextNumeric')){
                        strOperator.add(dataOper);
                    }
                }
                else if(oprtype=='Numeric'){
                    if(operands.datatype__c=='Numeric' || operands.datatype__c.equalsIgnoreCase('TextNumeric')){
                        strOperator.add(dataOper);
                    }
                }
                
            }        
        }
        return strOperator;
    }
    public static list<Data_Set_Column_Detail__c> getColumnsData(string dataSetId){      
        list<Data_Set_Column_Detail__c> lstcolumns=[select ds_col_name__c,column_id__c,datatype__c,dataset_id__c,
                                                    value_type__c,variable_type__c,Table_Data_Type__c,tb_col_nm__c
                                                    from Data_Set_Column_Detail__c 
                                                    where dataset_id__c=:dataSetId];        
        return lstcolumns;
    }
    public static list<Data_Set_Column_Detail__c> getColumnsDataByScenarioInstId(string scenarioInstanceId){
        Data_Set_Rule_Map__c ruleMap = [select dataset_id__c 
                                        from Data_Set_Rule_Map__c
                                        where scenario_rule_instance_id__c =: scenarioInstanceId limit 1];   
        String dataSetId= ruleMap.dataset_id__c;
        list<Data_Set_Column_Detail__c> lstcolumns=[select ds_col_name__c,column_id__c,datatype__c,dataset_id__c,
                                                    value_type__c,variable_type__c,Table_Data_Type__c,tb_col_nm__c
                                                    from Data_Set_Column_Detail__c 
                                                    where dataset_id__c=:dataSetId];
         return lstcolumns;
    }
    @AuraEnabled
    public static list<Data_Set_Rule_Map__c> getInputTableName(String scenarioInstanceId){
        list<Data_Set_Rule_Map__c> lstRuleMap = [select id,table_display_name__c,ds_type__c,dataset_id__c from Data_Set_Rule_Map__c
                                                 where ds_type__c in ('i','o') 
                                                 and scenario_rule_instance_id__c =: scenarioInstanceId];
        return lstRuleMap;
    }
    static boolean ValidateFeildsCategory(list<BROutputCriteria> lstCategoryDetails,String strCategName){
        for(BROutputCriteria cri : lstCategoryDetails){
            if(cri.categName.equalsIgnoreCase(strCategName))
                return true;
        }
        return false;
    }
    @AuraEnabled
    public static BROutputCriteria AddDynamicData(String lstCriteria,String scenarioId, String strCategName,
                                                String strDataType,
                                                String strValueType,String strValues, String isNewCateg)
    {       
        BROutputCriteria cri = new BROutputCriteria();
        boolean isValid = true;
        list<BROutputCriteria> lstCategoryDetails = (list<BROutputCriteria>)JSON.deserialize(lstCriteria,list<BROutputCriteria>.class);    
        //if its a new category check in aother scenarios if its being used
       /* if(isNewCateg == 'true'){
            if(lstCategoryDetails.size()==0){
                if(CPGUtility.ValidateDerivedFields(scenarioId,strCategName))
                    return null;
            }
            else if (lstCategoryDetails.size()> 0){
                if(ValidateFeildsCategory(lstCategoryDetails,strCategName))
                    return null;
            }
        }*/
         if(CPGUtility.ValidateDerivedFields(scenarioId,strCategName, false))
                    return null;
        cri.categName = strCategName;
        cri.dataType = strDataType;
        cri.valueType = strValueType;
        cri.selValue='';
        if(strValueType=='Discrete'){
            list<String> arr= new list<String>();
            arr.add('---');
            cri.isDropdown=true;  
            for(String str : strValues.split(','))
                arr.add(str);            
            cri.values=arr;
        }
        else
            cri.isDropdown=false;            
        
        return cri;
    }
    
    @AuraEnabled
    public static BROutputCriteria getCategoryFieldData(String categName, String lstCriteria)
    {               
        list<BROutputCriteria> lstCategoryDetails = (list<BROutputCriteria>)JSON.deserialize(lstCriteria,list<BROutputCriteria>.class);    
        
        for(BROutputCriteria cri: lstCategoryDetails){ 
            if(cri.categName.containsIgnoreCase(categName)){
                return cri;
            }
        }
        return null;
    }
    
    @AuraEnabled
    public static BRWrapBlock.ElseCriteria AddElseDataCriteria(String strCategName,String strDataType,
                                                String strValueType,String strValues)
    {
        BRWrapBlock.ElseCriteria cri = new BRWrapBlock.ElseCriteria();
        cri.categName = strCategName;
        cri.dataType = strDataType;
        cri.valueType = strValueType;
        cri.selValue='';
        if(strValueType=='Discrete'){
            list<String> arr= new list<String>();
            arr.add('---');
            cri.isDropdown=true;  
            for(String str : strValues.split(','))
            arr.add(str);            
            cri.values=arr;
        }
        else
            cri.isDropdown=false;
        return cri;
    }
    
    
    @AuraEnabled
    public static List<Business_Rule_Type_Master__c> getBusinessRuleTypeMaster(){
        
        List<Business_Rule_Type_Master__c> lstBusinessRuleTypeMaster = [select Id,Name from  Business_Rule_Type_Master__c
                                                                      where Component_Type__r.Name='Derived Field'];
        return lstBusinessRuleTypeMaster;
    }
    public static BRWrapCriteria AddaCriteria(boolean isFrst, list<Data_Set_Column_Detail__c> lstColumns)
    {                
         map<string, string> mapCols = new map<string, string>();
        for(Data_Set_Column_Detail__c col : lstColumns){
            mapCols.put(col.tb_col_nm__c,col.variable_type__c);
        }
        
        BRWrapCriteria wrapCriteria = new BRWrapCriteria();
        wrapCriteria.seqNo = 1;
        if(isFrst){
            wrapCriteria.criNameOptions = new string[] {'-'};
                wrapCriteria.criName = '-';
        }
        else{
            wrapCriteria.criNameOptions = new string[] {'And','OR'};
                wrapCriteria.criName = 'AND';
        }       
        if(lstColumns.size()>0){  
            List<BRWrapBlock.DataSetColumnDetails> dtSetColDetails=new List<BRWrapBlock.DataSetColumnDetails>();
            for(Data_Set_Column_Detail__c cols:lstColumns){
                dtSetColDetails.add(new BRWrapBlock.DataSetColumnDetails(cols.ds_col_name__c,cols.datatype__c,cols.tb_col_nm__c,cols.variable_type__c));
            }
                       
            //wrapCriteria.fieldName = lstColumns;   
            wrapCriteria.fieldName= dtSetColDetails;        
            String[] operators = getOperators(lstColumns[0].datatype__c); //data type of first column 
            wrapCriteria.opVal = operators;
            wrapCriteria.selOpVal = '0@0@0@'+operators[0];
            wrapCriteria.selFieldName = '0@0@0@'+lstColumns[0].datatype__c+'@'+lstColumns[0].tb_col_nm__c+'@'+mapCols.get(lstColumns[0].tb_col_nm__c);
        }        
        wrapCriteria.fieldVal = '';
        wrapCriteria.fieldType = '';        
        return WrapCriteria;
    }
    
    @AuraEnabled
    public static string SaveCheck(String categoryData, String wrapperData, 
                                   String ruleName,String scenarioId, String ruleId, String DataSetId,
                                  String ruleType, String selLevel, String custPrior,String deletedCategoryFields)
    {      
        system.debug('DataSetId>>>'+DataSetId);
        Id busiId;        
        list<Data_Set_Column_Detail__c> lstColumns = getColumnsData(DataSetId);        
        String scenarioLevelId = CPGUtility.GetScenarioId(scenarioId);

        list<Business_rules__c> aggRules= [select id, aggregate_level__c,Business_Rule_Type_Master__c,
                                           ScenarioRuleInstanceDetails__c
                                           from Business_rules__c
                                           where Business_Rule_Type_Master__r.name='Aggregate'
                                           and Scenario__c=: scenarioLevelId];    
        Savepoint sp = Database.setSavepoint();
        try{
            list<BROutputCriteria> lstCategoryDetails = (list<BROutputCriteria>)JSON.deserialize(categoryData,list<BROutputCriteria>.class);    
            list<BROutputCriteria> lstDeletedCategoryFields = (list<BROutputCriteria>)JSON.deserialize(deletedCategoryFields,list<BROutputCriteria>.class);    
            list<BRWrapBlock> lstWrapperBlock = (list<BRWrapBlock>)JSON.deserialize(wrapperData,list<BRWrapBlock>.class);    
            
            //Check If business rule exists in all scenariodetails
            boolean isNewRule= true;
            if(ruleId != '')
                isNewRule = false;            
            boolean isExists= CPGUtility.ValidateBusinessRules(scenarioId,ruleName,isNewRule);                
            if(isExists){
                return 'Business Rule Name already exists.';
            }
            
            if(ruleId != ''){ // it's not an existing ruleId                
                UpdateBusinessRule(ruleId, ruleName,ruleType,selLevel,custPrior,aggRules);
                deleteBusinessCategories(ruleId,lstCategoryDetails,lstDeletedCategoryFields,DataSetId);
                busiId=ruleId;
            }
            else{               
                busiId= SaveBusinessRule(ruleName,scenarioId,ruleType,selLevel,custPrior,aggRules);      
            }
            map<Integer,Category_Rule_Entity_Detail__c> mapBlockEntity= SaveCategoryBlockRuleEntity(lstWrapperBlock,busiId);
            map<Integer,List<ID>> mapGroupEntity= SaveCategoryGroupRuleEntity(lstWrapperBlock,busiId,mapBlockEntity);
            SaveCategoryRuleCriteria(lstWrapperBlock,mapGroupEntity,lstColumns);
            SaveMetaData(lstCategoryDetails, busiId);
            SaveOutputCategory(lstWrapperBlock,mapBlockEntity);
            SaveBusinessRuleFieldMap(busiId,lstCategoryDetails,scenarioId,lstWrapperBlock,lstColumns,dataSetId);
            if(ruleType == ''){
                if(!CPGUtility.UpdateExecutionSequences(scenarioId)){
                    throw new DmlException(CPGConstants.CYCLICREFERENCEERROR);             
                }  
            }
        }catch(Exception ex){
            Database.rollback(sp);
            return ex.getMessage();
            //+ex.getStackTraceString()+ex.getLineNumber();
        }
        return 'true';        
    }
    public static void UpdateBusinessRule(String ruleId, String ruleName,String ruleType,
                                          String selLevel, String custPrior,list<Business_rules__c> aggRules){
        Business_Rules__c rule = [select id from Business_Rules__c where id=:ruleId];
        rule.name=ruleName;  
        if(ruleType != ''){
            rule.aggregate_level__c=selLevel;
            rule.customer_prioritization__c=custPrior;
            if(ruleType != null || ruleType != ''){
                if(aggRules != null && aggRules.size()>0)
                    rule.Aggregate_Scenario_Rule_Instance__c=aggRules[0].ScenarioRuleInstanceDetails__c;
                system.debug('ishita'+ruleType);
                if(ruleType.containsIgnoreCase('Increase'))
                    rule.Prioritization_Order__c='asc';
                else
                    rule.Prioritization_Order__c='desc';
            }
        }
        update rule;        
    }
    public static void deleteBusinessCategories(String ruleId,list<BROutputCriteria> lstCategoryDetails,
        list<BROutputCriteria> lstDeletedCategoryFields,String dataSetId)
    {
        list<Category_Derived_Variable_Metadata__c> lstMetaData=[select id from Category_Derived_Variable_Metadata__c 
                                                                 where Business_Rule_Id__c =: ruleId];
        delete lstMetaData;
        
        set<String> setOutputs = new set<String>();
        for(BROutputCriteria output : lstDeletedCategoryFields){
            setOutputs.add(output.categName);
        }
        system.debug('setOutputs-->'+setOutputs);
        list<Data_Set_Column_Detail__c> lstColumns = [select id 
                                                       from Data_Set_Column_Detail__c
                                                      where dataset_id__c=: dataSetId 
                                                      and ds_col_name__c in: setOutputs];
        system.debug('lstColumns-->'+lstColumns);
        delete lstColumns;
        
        list<Business_Rule_FieldMap_Details__c> lstFieldMap=[select id from Business_Rule_FieldMap_Details__c
                                                             where Business_Rule__c =: ruleId];
        delete lstFieldMap;
        
        list<Category_Rule_Entity_Detail__c> lstRuleEntity = [select id,category_type__c from Category_Rule_Entity_Detail__c
                                                              where Business_Rule__c =: ruleId];
        Set<id> setBlock = new Set<id>();
        Set<id> setGroup = new Set<id>();
        for(Category_Rule_Entity_Detail__c blockEntity : lstRuleEntity){
            if(blockEntity.category_type__c == 'Block')
                setBlock.add(blockEntity.id);
            else
                setGroup.add(blockEntity.id);
        }        
        //grps
        list<Category_Rule_Criteria_Detail__c> lstGrpEntity = [select id from Category_Rule_Criteria_Detail__c
                                                               where Category_Rule_Entity_Detail__c in: setGroup];        
        delete lstGrpEntity;
        
        list<Category_Rule_Output_Detail__c> lstOutPutDetail= [select id from Category_Rule_Output_Detail__c 
                                                      where Category_Rule_Entity_Detail__c in: setBlock];
        delete lstOutPutDetail;        
        delete lstRuleEntity;   
    }
    
    public static Id SaveBusinessRule(String ruleName,String scenarioId,String ruleType, 
                                      String selLevel, String custPrior, list<Business_rules__c> aggRules){
        Business_Rule_Type_Master__c ruleMaster = new Business_Rule_Type_Master__c();
        if(ruleType != '')
            ruleMaster = [select id from Business_Rule_Type_Master__c 
                          where name =: ruleType
                          limit 1];
        else            
            ruleMaster = [select id from Business_Rule_Type_Master__c 
                          where name ='Category'
                          limit 1];
        
        Scenario_Rule_Instance_Details__c scenarioRule = [select id from Scenario_Rule_Instance_Details__c   
                                                          where id =: scenarioId
                                                          limit 1];
        
        Business_Rules__c rule = new Business_Rules__c();
        rule.name=ruleName;
        rule.Business_Rule_Type_Master__c=ruleMaster.id;
        rule.ScenarioRuleInstanceDetails__c=scenarioRule.id;
        rule.Is_Derived__c=true;
        rule.Is_Mandatory__c=true;        
        if(ruleType != null || ruleType != ''){
            rule.Customer_Prioritization__c =custPrior;
            rule.Aggregate_Level__c=selLevel;
            if(aggRules != null && aggRules.size()>0)
                rule.Aggregate_Scenario_Rule_Instance__c=aggRules[0].ScenarioRuleInstanceDetails__c;
            if(ruleType.containsIgnoreCase('Increase'))
                rule.Prioritization_Order__c='asc';
            else
                rule.Prioritization_Order__c='desc';
        }
        insert rule;
        return rule.id;
    }    
    
    public static void SaveOutputCategory(list<BRWrapBlock> lstWrapperBlock,map<Integer,Category_Rule_Entity_Detail__c> mapBlockEntity){
        list<Category_Rule_Output_Detail__c> lstRuleOutput = new list<Category_Rule_Output_Detail__c>();
        Integer seq=1;
        Integer elseSeq=0;
        for(BRWrapBlock block : lstWrapperBlock){               
            if(mapBlockEntity.get(block.selPriority)!= null && mapBlockEntity.get(block.selPriority).Category_Type__c!='Else'){            
                for(BROutputCriteria cri : block.lstOutputCriteria){                
                    Category_Rule_Output_Detail__c outputCategory = new Category_Rule_Output_Detail__c();
                    outputCategory.Category_Rule_Entity_Detail__c=mapBlockEntity.get(block.selPriority).id;
                    outputCategory.Derived__c= cri.categName;            
                    outputCategory.Sequence__c=String.valueOf(block.selPriority);
                    outputCategory.Variable_Value__c= cri.selValue; 
                    lstRuleOutput.add(outputCategory);                       
                }   
            }
            else{
                elseSeq= seq;
            }
            seq++;
        }        
        
        for(BRWrapBlock.ElseCriteria cri : lstWrapperBlock[0].lstElseCriteria){                    
            Category_Rule_Output_Detail__c outputCategory = new Category_Rule_Output_Detail__c();
            outputCategory.Category_Rule_Entity_Detail__c=mapBlockEntity.get(seq).id;
            outputCategory.Derived__c= cri.categName;            
            outputCategory.Sequence__c=String.valueOf(elseSeq);
            outputCategory.Variable_Value__c= cri.selValue; 
            lstRuleOutput.add(outputCategory);
        }  
        insert lstRuleOutput;
    }    
    
    public static void SaveMetaData(list<BROutputCriteria> lstCategoryDetails,Id busiId){
        list<Category_Derived_Variable_Metadata__c> lstMetadata = new list<Category_Derived_Variable_Metadata__c>();
        
        for(BROutputCriteria cri : lstCategoryDetails){
            Category_Derived_Variable_Metadata__c metadata = new Category_Derived_Variable_Metadata__c();
            metadata.Business_Rule_Id__c = busiId;
            metadata.DataType__c = cri.dataType;    //inetger / string
            metadata.Field_Name__c= cri.categName;  // name of category  
            if(cri.values != null){
                String permValues = String.valueOf(cri.values); //comma searetd values                
                permValues= permValues.replaceAll( '\\s+', '');
                permValues= permValues.replaceAll( '\\(', '');
                permValues= permValues.replaceAll( '\\)', '');
                permValues= permValues.replaceAll( '\\---,', '');
                metadata.Permitted_Values__c= permValues;
            }
            else
                metadata.Permitted_Values__c='';
            metadata.Value_Type__c= cri.valueType;  //Discere/continous
            if(cri.isDisabled == null)
                cri.isDisabled= false;
            metadata.isDisabled__c=cri.isDisabled;
            metadata.childDependent__c=cri.childDependent;
            lstMetadata.add(metadata);
        }
        insert lstMetadata;
    }
    
    public static map<Integer,Category_Rule_Entity_Detail__c> SaveCategoryBlockRuleEntity(list<BRWrapBlock> lstWrapperBlock,Id busiRuleId){        
       list<Category_Rule_Entity_Detail__c> lstEntities = new list<Category_Rule_Entity_Detail__c>();
        Integer priority=0;
        for(BRWrapBlock wrapData : lstWrapperBlock){
            Category_Rule_Entity_Detail__c ruleEntity = new Category_Rule_Entity_Detail__c();            
            ruleEntity.Business_Rule__c= busiRuleId;            
            if(wrapData.selPriority==1) //1 is a if
                ruleEntity.Category_Type__c='If';
            else
                ruleEntity.Category_Type__c='Else If';   
            
            ruleEntity.Entity_Type__c='Block';
            ruleEntity.Priority__c=String.valueOf(wrapData.selPriority);
            ruleEntity.Display_Expression__c=wrapData.criteriaLogic;
            ruleEntity.Exec_Expression__c=wrapData.executionLogic;
            
            lstEntities.add(ruleEntity);
            priority++;
        }
        priority++;
                
        Category_Rule_Entity_Detail__c ruleEntity = new Category_Rule_Entity_Detail__c();            
        ruleEntity.Business_Rule__c= busiRuleId; 
        ruleEntity.Category_Type__c='Else';
        ruleEntity.Entity_Type__c='Block';
        ruleEntity.Priority__c= String.valueOf(priority);            
        lstEntities.add(ruleEntity);        
        //insert block first
        insert lstEntities;        
        //Map of blocks id
        map<Integer,Category_Rule_Entity_Detail__c> mapBlockEntity = new map<Integer,Category_Rule_Entity_Detail__c>();        
        for(Category_Rule_Entity_Detail__c categDet : [select id,Priority__c,Category_Type__c from Category_Rule_Entity_Detail__c 
                                                       where Business_Rule__c=:busiRuleId and Entity_Type__c='Block'
                                                      order by Priority__c asc])
        {
            mapBlockEntity.put(Integer.valueOf(categDet.Priority__c), categDet);            
        }
        //Create child groups against each block
                    
        return mapBlockEntity;
    }    
    public static map<Integer,List<ID>> SaveCategoryGroupRuleEntity(list<BRWrapBlock> lstWrapperBlock,Id busiRuleId,map<Integer,Category_Rule_Entity_Detail__c> mapBlockEntity){        
        list<Category_Rule_Entity_Detail__c> lstEntities = new list<Category_Rule_Entity_Detail__c>(); 
        for(BRWrapBlock block : lstWrapperBlock){ 
            Integer blockSeq =block.selPriority;
            if(mapBlockEntity.get(blockSeq).Category_Type__c != 'Else'){
                for(Integer i=0 ; i < block.lstWrapGroup.size(); i++){                
                    BRWrapBlock.WrapGroup grp = block.lstWrapGroup[i];
                    Category_Rule_Entity_Detail__c ruleEntityGrp = new Category_Rule_Entity_Detail__c();                
                    ruleEntityGrp.Business_Rule__c= busiRuleId;            
                    ruleEntityGrp.Entity_Type__c='Group';
                    ruleEntityGrp.Parent_Entity__c=mapBlockEntity.get(blockSeq).id;                
                    ruleEntityGrp.Priority__c= String.valueOf(i+1);
                    if(i != 0)
                        ruleEntityGrp.Logic_Operator__c=block.lstWrapGroup[i].selGroupOp;                
                    lstEntities.add(ruleEntityGrp);
                }
            }
        }           
        
        insert lstEntities;
        
        //Get map of groups id        
        map<Integer,List<ID>> mapGroupEntity = new map<Integer,List<ID>>();        
        for(Category_Rule_Entity_Detail__c categDet : [select id,Entity_Type__c,Priority__c,Parent_Entity__c,
                                                       Parent_Entity__r.Priority__c
                                                       from Category_Rule_Entity_Detail__c 
                                                       where Business_Rule__c=:busiRuleId])
        {
            if(categDet.Entity_Type__c=='Group')
            {
                //a block can have multiple groups                
                if(mapGroupEntity.containsKey(Integer.valueof(categDet.Parent_Entity__r.Priority__c))){
                    List<ID> grpId= mapGroupEntity.get(Integer.valueof(categDet.Parent_Entity__r.Priority__c));
                    grpId.add(categDet.Id);
                    mapGroupEntity.put((Integer.valueof(categDet.Parent_Entity__r.Priority__c)), grpId);                     
                }
                else{
                    mapGroupEntity.put((Integer.valueof(categDet.Parent_Entity__r.Priority__c)), new List<Id> {categDet.id});                    
                }
            }
        }
        return mapGroupEntity;        
    }    
    
    public static void SaveCategoryRuleCriteria(list<BRWrapBlock> lstWrapperBlock,map<Integer,List<ID>> mapGroupEntity, 
                                         list<Data_Set_Column_Detail__c> lstColumns)
    {   
        map<String, String> mapColumns = new map<String, String>();        
        for(Data_Set_Column_Detail__c col : lstColumns){
            mapColumns.put(col.ds_col_name__c, col.datatype__c);
        }
                                            
        list<Category_Rule_Criteria_Detail__c> lstRuleDetail = new list<Category_Rule_Criteria_Detail__c>();        
        for(BRWrapBlock block : lstWrapperBlock){  
            
            list<id> grpsId = mapGroupEntity.get(block.selPriority);     //1,2       
            Integer grpSeq=0;
            for(BRWrapBlock.WrapGroup grp : block.lstWrapGroup){                  
                Id grpId= grpsId[grpSeq];
                for(BRWrapCriteria cri : grp.lstwrapCriteria){
                    Category_Rule_Criteria_Detail__c ruleDetail = new Category_Rule_Criteria_Detail__c();
                    ruleDetail.Category_Rule_Entity_Detail__c = grpId;
                    ruleDetail.Criteria_operator__c=cri.selOpVal.split('@')[3]; //equal - not equal
                    if(cri.selFieldName.contains('@')){
                        String colName=cri.selFieldName.split('@')[4];
                        ruleDetail.Field__c=colName;                    
                        ruleDetail.FieldDataType__c =cri.selFieldName.split('@')[3];
                    }
                    else{
                        ruleDetail.Field__c=cri.selFieldName;                    
                        ruleDetail.FieldDataType__c = mapColumns.get(cri.selFieldName);
                    }
                    
                    ruleDetail.Logic_Operator__c=cri.criName;
                    ruleDetail.Sequence__c=String.valueOf(cri.seqNo);
                    
                    if(cri.fieldVal != null && cri.fieldVal != ''){
                        if(cri.fieldVal.contains('\'')){
                            cri.fieldVal=cri.fieldVal.replace('\'','');
                        }
                    }
                    ruleDetail.Param_value__c=cri.fieldVal;
                    lstRuleDetail.add(ruleDetail);
                }               
                grpSeq++;
            }            
        }
        insert lstRuleDetail;
    }
    
    public static void AddCategoryToFeilds(list<BROutputCriteria> lstCategoryDetails,String scenarioId,
                                    list<Data_Set_Column_Detail__c> lstColumns,string dataSetId)
    {
        
        list<Data_Set_Column_Detail__c> lstCols = new list<Data_Set_Column_Detail__c>();
        for(BROutputCriteria cri : lstCategoryDetails){       
             string tblColName=cri.categName.replace('#','total').replace(' ','_').toLowerCase();
             List<Data_Set_Column_Detail__c > lst=[select Id from Data_Set_Column_Detail__c
                                                  where tb_col_nm__c= :tblColName and dataset_id__c= :dataSetId];
            if(lst==null || (lst!=null && lst.size()==0)){
                Data_Set_Column_Detail__c col = new Data_Set_Column_Detail__c();
                col.dataset_id__c= lstColumns[0].dataset_id__c;
                col.ds_col_name__c=cri.categName;
                col.datatype__c=cri.dataType;
                col.Table_Data_Type__c=cri.dataType.toLowerCase();
                col.variable_type__c='Derived';
                if(cri.isDropdown)
                    col.value_type__c='Discrete';
                else
                    col.value_type__c='Continuous';                    
                cri.categName = cri.categName.replace(' ','_');
                if(cri.categName.contains('#'))
                    cri.categName = cri.categName.replace('#','total');    
                col.tb_col_nm__c=cri.categName.toLowerCase();
                lstCols.add(col);
            }
        }
        insert lstCols;        
    }
    public static void SaveBusinessRuleFieldMap(Id busiId,list<BROutputCriteria> lstCategoryDetails, String scenarioId,
                                         list<BRWrapBlock> lstWrapperBlock, list<Data_Set_Column_Detail__c> lstColumns,
                                         string dataSetId)
    {        
        //Below list is to add derived fields as Output to Business_Rule_FieldMap_Details__c, 
        //if they are being created as a derived field in category module
        list<Business_Rule_FieldMap_Details__c> lstFieldMap = new list<Business_Rule_FieldMap_Details__c>();
        for(BROutputCriteria cri : lstCategoryDetails){
            Business_Rule_FieldMap_Details__c fieldMap = new Business_Rule_FieldMap_Details__c();
            fieldMap.Business_Rule__c=busiId;
            fieldMap.IO_Flag__c='O';
            //string paramName =cri.categName.replace('_',' ');
            string paramName =cri.categName;
            fieldMap.Param_Name__c=paramName;
            fieldMap.Param_Data_Type__c= cri.dataType;
            fieldMap.Param_Type__c= 'Derived';
            lstFieldMap.add(fieldMap);          
        }
        
        //Below list is to add derived fields as Input to Business_Rule_FieldMap_Details__c, 
        //if they are being used as input data in category
        list<Business_Rule_FieldMap_Details__c> lstDerivedCols = new list<Business_Rule_FieldMap_Details__c>();
        if(lstWrapperBlock!=null){
            for(BRWrapBlock block : lstWrapperBlock){
                for(BRWrapBlock.WrapGroup grp : block.lstwrapGroup){
                    for(BRWrapCriteria cri : grp.lstWrapCriteria){
                        if(cri.selFieldName.split('@')[5] == 'Derived'){
                            Business_Rule_FieldMap_Details__c fieldMap = new Business_Rule_FieldMap_Details__c();
                            fieldMap.Business_Rule__c=busiId;
                            fieldMap.IO_Flag__c='I';
                            //string paramName =cri.selFieldName.split('@')[4].replace('_',' ');
                            string paramName =cri.selFieldName.split('@')[4];
                            fieldMap.Param_Name__c=paramName;
                            fieldMap.Param_Data_Type__c= cri.selFieldName.split('@')[3];
                            fieldMap.Param_Type__c= 'Derived';
                            lstDerivedCols.add(fieldMap);
                        }
                    }
                }
            }
        }
        if(lstDerivedCols.size()>0)
            insert lstDerivedCols;
        insert lstFieldMap;
       
        AddCategoryToFeilds(lstCategoryDetails,scenarioId,lstColumns,dataSetId);
                
    }
    
    @AuraEnabled
    public static Types_List__mdt[] getTypesList(){ 
        List<Types_List__mdt> typesList = [Select Id,Label, Type__c,Value__c from Types_List__mdt ];        
        return  typesList; 
    }
    public static BRWrapBlock.WrapGroup AddGroup(boolean isFrst,list<Data_Set_Column_Detail__c> lstColumns)
    {
        BRWrapBlock.WrapGroup grp = new BRWrapBlock.WrapGroup();             
        list<BRWrapCriteria> lstCrtitera= new list<BRWrapCriteria>();
        BRWrapCriteria wrapCriteria = AddaCriteria(isFrst,lstColumns);
        list<BRWrapBlock.WrapGroup> nestedGrp= new list<BRWrapBlock.WrapGroup>(); 
        lstCrtitera.add(wrapCriteria);
        grp.lstwrapCriteria=lstCrtitera;   
        grp.lstNestedGroup = nestedGrp;
        grp.selGroupOp='AND';
        return grp; 
    }
    
    public static BRWrapBlock AddBlock(boolean isFrst,List<BROutputCriteria> lstCriteria, String DataSetId){  
        lstColumns=getColumnsData(DataSetId);
        List<BRWrapBlock.ElseCriteria> lstElseCriteria = new List<BRWrapBlock.ElseCriteria>();       
        BRWrapBlock block =new BRWrapBlock();        
        if(lstCriteria.size()>0){
            block.lstOutputCriteria =lstCriteria;
            block.lstElseCriteria= lstElseCriteria;
        }
        system.debug('===isFrst====='+isFrst);
        system.debug('===lstColumns====='+lstColumns);
        BRWrapBlock.WrapGroup grp=AddGroup(isFrst,lstColumns); 
       
        List<BRWrapBlock.WrapGroup> lstWrapGrp = new List<BRWrapBlock.WrapGroup>();        
        lstWrapGrp.add(grp);    
        
        block.lstWrapGroup=lstWrapGrp;    
        block.criteriaLogic='(1)';
        
        return block;
    }
    @AuraEnabled
    public static BRRuleDetails getRuleName(String scenarioId,String ruleId){
        Business_Rules__c rule = [select id,name,aggregate_level__c,customer_prioritization__c,
                                  Business_Rule_Type_Master__r.name
                                  from Business_Rules__c
                                  where id=:ruleId and
                                  ScenarioRuleInstanceDetails__c=: scenarioId limit 1];
        BRRuleDetails obj = new BRRuleDetails();  
        obj = FillRuleDetails(scenarioId,obj); 
        obj.ruleName=rule.Name;
        obj.selRuleType = rule.Business_Rule_Type_Master__r.name;
        obj.selLevel = rule.aggregate_level__c;            
        obj.selCustPrior = rule.customer_prioritization__c;
        
        return obj;
    }
    @AuraEnabled
    public static list<BROutputCriteria> AddOutputField(String ruleType)
    {       
        list<BROutputCriteria> lstOutputCriteria= new list<BROutputCriteria>();
        list<Rule_Type_Derived_Variable_Metadata__c> lstMetaData = [select Field_Name__c,Data_Type__c,Value_Type__c,
                                                                    isDisabled__c,childDependent__c,
                                                                    Permitted_Values__c,Business_Rule_Type_Master__r.name  
                                                                    from Rule_Type_Derived_Variable_Metadata__c  
                                                                    where Business_Rule_Type_Master__r.name=: ruleType];
        for(Rule_Type_Derived_Variable_Metadata__c metadata : lstMetaData){
            BROutputCriteria cri = new BROutputCriteria();  
            cri.categName = metadata.Field_Name__c;
            cri.dataType = metadata.Data_Type__c;
            cri.valueType = metadata.Value_Type__c;
            cri.isDropdown=false;  
            cri.isDisabled = metadata.isDisabled__c;
            cri.childDependent=metadata.childDependent__c;
            lstOutputCriteria.add(cri);
        }
        return lstOutputCriteria;
    }
    @AuraEnabled
    public static list<BRWrapBlock> initialiseBlock(String scenarioId,String ruleId, String ruleType){    
        Data_Set_Rule_Map__c ruleMap = [select dataset_id__c 
                                        from Data_Set_Rule_Map__c
                                        where scenario_rule_instance_id__c =: scenarioId limit 1];   
        String dataSetId= ruleMap.dataset_id__c;
        
        String executeExpression='';
        list<BRWrapBlock> lstWrapBlock = new list<BRWrapBlock>();
        if(ruleId != ''){        
            lstWrapBlock = InitialiseRule(ruleId,dataSetId);
        }
        else{            
            List<BROutputCriteria> lstCriteria = new List<BROutputCriteria>();
            if(ruleType != '')
                lstCriteria = AddOutputField(ruleType);
            BRWrapBlock wrapBlock = AddBlock(true,lstCriteria,dataSetId);                
            wrapBlock.criteriaSeq=1;
            Integer intP= 1;
            list<integer> lstInte= new list<integer>();
            lstInte.add(intP);                
            wrapBlock.priority=lstInte;           
            wrapBlock.selPriority=1;
            lstWrapBlock.add(wrapBlock);
        }
        return lstWrapBlock;
    }
    
    public static list<BRWrapBlock> InitialiseRule(String businessId,String dataSetId){
        map<id, list<id>> mapGrp = new map<id, list<id>>();
        map<id, Category_Rule_Entity_Detail__c> mapEntity = new map<id, Category_Rule_Entity_Detail__c>();
        list<id> lstBlockId = new List<id>();
        list<id> lstGrpId = new List<id>();
        list<BRWrapBlock> lstWrapBlock = new list<BRWrapBlock>();   
        list<Category_Rule_Entity_Detail__c> lstRuleEntity= [select id,Parent_Entity__c,Category_Type__c,Logic_Operator__c,
                                                             Entity_Type__c,Display_Expression__c,Exec_Expression__c,
                                                             Priority__c,FormulaPriority__c from Category_Rule_Entity_Detail__c 
                                                             where Business_Rule__c=: businessId order by FormulaPriority__c asc];  
        if(lstRuleEntity != null){
        for(Category_Rule_Entity_Detail__c entity : lstRuleEntity){        
            mapEntity.put(entity.id, entity);
            if(entity.Entity_Type__c =='Group'){
                lstGrpId.add(entity.id);                
                if(mapGrp.containsKey(entity.Parent_Entity__c)){
                    List<id> grpId= mapGrp.get(entity.Parent_Entity__c);
                    grpId.add(entity.Id);
                    mapGrp.put(entity.Parent_Entity__c, grpId);                     
                }
                else{
                    mapGrp.put(entity.Parent_Entity__c, new List<Id> {entity.id});                    
                }
            }
            else if(entity.Entity_Type__c =='Block'){
                lstBlockId.add(entity.id);
            }
        }
        map<id,list<Category_Rule_Criteria_Detail__c>> mapRuleCri = new map<id,list<Category_Rule_Criteria_Detail__c>>();      
            for(Category_Rule_Criteria_Detail__c criDetail : [select id,Criteria_operator__c, Field__c,Logic_Operator__c,
                                                              Sequence__c,Param_value__c,Category_Rule_Entity_Detail__c,
                                                              FieldDataType__c
                                                              from Category_Rule_Criteria_Detail__c
                                                              where Category_Rule_Entity_Detail__c in: lstGrpId
                                                             order by Sequence__c asc ])
            {
            if(mapRuleCri.containsKey(criDetail.Category_Rule_Entity_Detail__c)){
                    List<Category_Rule_Criteria_Detail__c> lstCri= mapRuleCri.get(criDetail.Category_Rule_Entity_Detail__c);
                    lstCri.add(criDetail);
                    mapRuleCri.put(criDetail.Category_Rule_Entity_Detail__c, lstCri);   
                }
                else
                    mapRuleCri.put(criDetail.Category_Rule_Entity_Detail__c, new List<Category_Rule_Criteria_Detail__c> {criDetail});
        }
         map<String,Category_Derived_Variable_Metadata__c> mapMetaData= new  map<String,Category_Derived_Variable_Metadata__c>();
        for(Category_Derived_Variable_Metadata__c metadata : [select id,DataType__c,Field_Name__c,Permitted_Values__c,
                                                              Value_Type__c,isDisabled__c,childDependent__c
                                                              from Category_Derived_Variable_Metadata__c
                                                              where Business_Rule_Id__c=: businessId])
        {            
            mapMetaData.put(metadata.Field_Name__c,metadata);
        }
            
        map<id,list<Category_Rule_Output_Detail__c>> mapCateg= new map<id,list<Category_Rule_Output_Detail__c>>();
            for(Category_Rule_Output_Detail__c detail: [select id,Category_Rule_Entity_Detail__c,
                                                        Derived__c,Variable_Value__c
                                                        from Category_Rule_Output_Detail__c
                                                        where Category_Rule_Entity_Detail__c in:lstBlockId])
            {
                if(mapCateg.containsKey(detail.Category_Rule_Entity_Detail__c)){
                    List<Category_Rule_Output_Detail__c> lstCri= mapCateg.get(detail.Category_Rule_Entity_Detail__c);
                    lstCri.add(detail);
                    mapCateg.put(detail.Category_Rule_Entity_Detail__c, lstCri);   
                }
                else
                    mapCateg.put(detail.Category_Rule_Entity_Detail__c, new List<Category_Rule_Output_Detail__c> {detail});
            }
        
        Integer seq=1;
        String categType='';
        Id elseBlockId;
        
        list<integer> lstInte= new list<integer>();
        for(Integer i=0; i<lstBlockId.size(); i++){
            lstInte.add(i+1);
        }
        Integer blockSeq=0;
        for(Id blockId : lstBlockId){            
            if(mapEntity.get(blockId).Category_Type__c=='Else'){
                categType='Else';
                elseBlockId=blockId;
            }
            else{
            BRWrapBlock block = CreateBlock(blockId,mapGrp,mapRuleCri,mapCateg,mapEntity,categType,
                                          dataSetId,blockSeq,mapMetaData);                                                               
            lstWrapBlock.add(block); 
                blockSeq++;
            }
        }
        list<BRWrapBlock.ElseCriteria> lstElseCri = new list<BRWrapBlock.ElseCriteria>();
        if(categType=='Else'){
            if(mapCateg.get(elseBlockId) != null){
                for(Category_Rule_Output_Detail__c categ : mapCateg.get(elseBlockId)){
                    Category_Derived_Variable_Metadata__c metaInfo = mapMetaData.get(categ.Derived__c);                    
                    BRWrapBlock.ElseCriteria cri= CreateElseCriteria(categ,metaInfo);
                    lstElseCri.add(cri);
                }
            }
            lstWrapBlock[0].lstElseCriteria=lstElseCri;
        }        
        }
        return lstWrapBlock;
    }
    public static BRWrapBlock.ElseCriteria CreateElseCriteria(Category_Rule_Output_Detail__c outputCategory,
                                           Category_Derived_Variable_Metadata__c metaInfo)
    {  
        BRWrapBlock.ElseCriteria cri = new BRWrapBlock.ElseCriteria();                
        cri.categName=outputCategory.Derived__c; 
        cri.dataType = metaInfo.DataType__c;    //inetger / string        
        
        list<String> arr= new list<String>();    
        cri.valueType = metaInfo.Value_Type__c; //Discere/continous
        if(metaInfo.Value_Type__c=='Discrete'){
            cri.isDropdown= true;
            if(outputCategory.Variable_Value__c == null)
                cri.selValue='---';
            else
                cri.selValue=outputCategory.Variable_Value__c;      
            
            if(metaInfo.Permitted_Values__c != null){
                arr.add('---');
                metaInfo.Permitted_Values__c=metaInfo.Permitted_Values__c.replace('(','');
                metaInfo.Permitted_Values__c=metaInfo.Permitted_Values__c.replace(')','');
                for(String str : metaInfo.Permitted_Values__c.split(','))
                    arr.add(str);  
                
                cri.values=arr;
            }
        }
        else{
            cri.selValue=outputCategory.Variable_Value__c;      
            cri.isDropdown= false;            
        }
        return cri;
    }   
    public static BROutputCriteria CreateCriteria(Category_Rule_Output_Detail__c outputCategory,
                                        Category_Derived_Variable_Metadata__c metaInfo)
    {        
        BROutputCriteria cri = new BROutputCriteria();                
        cri.categName=outputCategory.Derived__c; 
        cri.isDisabled = metaInfo.isDisabled__c;
        cri.childDependent=metaInfo.childDependent__c;
        if(outputCategory.Variable_Value__c == null)
            cri.selValue='---';
        else
            cri.selValue=outputCategory.Variable_Value__c;         
        cri.dataType = metaInfo.DataType__c;    //inetger / string        
        
        list<String> arr= new list<String>();            
            cri.isDropdown=true;  
        if(metaInfo.Permitted_Values__c != null){
            arr.add('---');
            metaInfo.Permitted_Values__c=metaInfo.Permitted_Values__c.replace('(','');
            metaInfo.Permitted_Values__c=metaInfo.Permitted_Values__c.replace(')','');
            for(String str : metaInfo.Permitted_Values__c.split(','))
                arr.add(str);             
            cri.values=arr;
        }
        cri.valueType = metaInfo.Value_Type__c; //Discere/continous
        if(metaInfo.Value_Type__c=='Discrete')
            cri.isDropdown= true;
        else
            cri.isDropdown= false;
        
        return cri;
    }    
    
    @AuraEnabled
    public static list<BROutputCriteria> DisplayCategories(Id ruleId){
        list<BROutputCriteria> lstOutputCriteria = new list<BROutputCriteria>();
        
        for(Category_Derived_Variable_Metadata__c metadata : [select id,DataType__c,Field_Name__c,Permitted_Values__c,
                                                              Value_Type__c,isDisabled__c,childDependent__c
                                                              from Category_Derived_Variable_Metadata__c
                                                              where Business_Rule_Id__c=: ruleId])
        {            
            BROutputCriteria cri = new BROutputCriteria();
            cri.dataType = metadata.DataType__c;    //inetger / string
            cri.categName = metadata.Field_Name__c; // name of category            
            list<String> arr= new list<String>();
            if(metadata.Permitted_Values__c != null){
                arr.add('---');
                metadata.Permitted_Values__c=metadata.Permitted_Values__c.replace('(','');
                metadata.Permitted_Values__c=metadata.Permitted_Values__c.replace(')','');                
                system.debug('metadata.Permitted_Values__c'+metadata.Permitted_Values__c);
                for(String str : metadata.Permitted_Values__c.split(','))
                    arr.add(str);                
                cri.values=arr;
            }
            
            cri.valueType = metadata.Value_Type__c; //Discere/continous
            if(metadata.Value_Type__c=='Discrete')
                cri.isDropdown= true;
            else
                cri.isDropdown= false;
            lstOutputCriteria.add(cri);
        }
        return lstOutputCriteria;
    }
     @AuraEnabled    
    public static Boolean ValidateCategory(String categName, String scenarioId){      
        if(CPGUtility.ValidateDerivedFields(scenarioId,categName, true))
            return false;
        else
            return true;
    }
    
    @AuraEnabled    
    public static list<BRWrapBlock> deleteFieldCategory(String lstWrapperBlock, String categName, String scenarioId){      
       list<BRWrapBlock> lstBlock = (List<BRWrapBlock>)JSON.deserialize(lstWrapperBlock, List<BRWrapBlock>.class);             
        
        string colName = categName.replace('_',' ');
        
        if(CPGUtility.ContainsReference('', colName, scenarioId))
            return null;
        else{
            //update all outputcriterais 
            for(BRWrapBlock block : lstBlock){
                list<BROutputCriteria> lstFieldsCriteria = block.lstOutputCriteria;
                for(integer i=0; i< lstFieldsCriteria.size(); i++){
                    if(lstFieldsCriteria[i].categName.containsIgnoreCase(categName)){  
                        DeleteFromDataSetColumnDetails(scenarioId,categName);
                        lstFieldsCriteria.remove(i);
                        break;
                    }
                }
            }
            
            //update all outputcriterais         
            list<BRWrapBlock.ElseCriteria> lstElseCrit = lstBlock[0].lstElseCriteria;
            for(integer i=0; i< lstElseCrit.size(); i++){
                if(lstElseCrit[i].categName.containsIgnoreCase(categName)){                
                    lstElseCrit.remove(i);
                }
            }
            
            return lstBlock;  
        }

    }
    public static void DeleteFromDataSetColumnDetails(string scenarioRuleInstanceDetailsId,string columnName){
        List<Data_Set_Rule_Map__c> lstDataSetRuleMap=new List<Data_Set_Rule_Map__c>();
        lstDataSetRuleMap=[select Id,dataset_id__c from Data_Set_Rule_Map__c 
                           where scenario_rule_instance_id__c= :scenarioRuleInstanceDetailsId and ds_type__c='I']; 
        if(lstDataSetRuleMap!=null && lstDataSetRuleMap.size()>0){
            string dataSetId=lstDataSetRuleMap[0].dataset_id__c;  
            delete[select Id from Data_Set_Column_Detail__c  where dataset_id__c= :dataSetId and 
                   variable_type__c ='Derived'  and ds_col_name__c = :columnName]  ;
        } 
    }
    
    @AuraEnabled    
    public static list<BROutputCriteria> deleteListFieldCategory(String lstCriteria,String categName){      
        list<BROutputCriteria> lstMainCriteria = (List<BROutputCriteria>)JSON.deserialize(lstCriteria, List<BROutputCriteria>.class);              
        for(integer i=0; i< lstMainCriteria.size(); i++){
            if(lstMainCriteria[i].categName.containsIgnoreCase(categName)){                
                lstMainCriteria.remove(i);
            }
        }
        return lstMainCriteria;
    }
    
    
    @AuraEnabled
    public static list<BROutputCriteria> displayEditFields(list<BROutputCriteria> lstCriteria, BROutputCriteria editCriteria){        
       //list<BROutputCriteria> lstCriteria = (List<BROutputCriteria>)JSON.deserialize(lstCategories, List<BROutputCriteria>.class);              
       /* for(BROutputCriteria cri : lstCriteria){
            if(cri.categName.containsIgnoreCase(editCriteria.categName)){                
                cri.dataType = metadata.DataType__c;    //inetger / string
                cri.categName = metadata.Field_Name__c; // name of category
               
                list<String> arr= new list<String>();
                if(metadata.Permitted_Values__c != null){
                    metadata.Permitted_Values__c=metadata.Permitted_Values__c.replace('(','');
                    metadata.Permitted_Values__c=metadata.Permitted_Values__c.replace(')','');
                    for(String str : metadata.Permitted_Values__c.split(','))
                        arr.add(str);            
                    cri.values=arr;
                }
                
                cri.valueType = metadata.Value_Type__c; //Discere/continous
                if(metadata.Value_Type__c=='Discrete')
                    cri.isDropdown= true;
                else
                    cri.isDropdown= false;
               
            }
        }
        return lstCriteria;*/
        return null;
    }
    @AuraEnabled    
    public static list<BRWrapBlock> UpdateOuputCategoryList(String lstWrapperBlock, String categName){      
        list<BRWrapBlock> lstBlock = (List<BRWrapBlock>)JSON.deserialize(lstWrapperBlock, List<BRWrapBlock>.class);             
        
        //update all outputcriterais 
        for(BRWrapBlock block : lstBlock){
            list<BROutputCriteria> lstFieldsCriteria = block.lstOutputCriteria;
            for(integer i=0; i< lstFieldsCriteria.size(); i++){
                if(lstFieldsCriteria[i].categName.containsIgnoreCase(categName)){                
                    lstFieldsCriteria.remove(i);
                }
            }
        }
        
        //update all outputcriterais         
        list<BRWrapBlock.ElseCriteria> lstElseCrit = lstBlock[0].lstElseCriteria;
        for(integer i=0; i< lstElseCrit.size(); i++){
            if(lstElseCrit[i].categName.containsIgnoreCase(categName)){                
                lstElseCrit.remove(i);
            }
        }        
        return lstBlock;  
    }
    
    @AuraEnabled    
    public static list<BROutputCriteria> UpdateOuputCategoryList(String lstCriteria,String categName,String updatedCriteria){              
        list<BROutputCriteria> lstMainCriteria = (List<BROutputCriteria>)JSON.deserialize(lstCriteria, List<BROutputCriteria>.class);              
        BROutputCriteria updateCri = (BROutputCriteria)JSON.deserialize(updatedCriteria, BROutputCriteria.class);              
        
        for(integer i=0; i< lstMainCriteria.size(); i++){
            if(lstMainCriteria[i].categName.containsIgnoreCase(categName)){                
                lstMainCriteria.remove(i);
                lstMainCriteria.add(updateCri);
            }
        }
        return lstMainCriteria;
    }
    
    public static BRWrapBlock CreateBlock(Id blockId, map<id, list<id>> mapGrp,
                                 map<id,list<Category_Rule_Criteria_Detail__c>> mapRuleCri,
                                 map<id,list<Category_Rule_Output_Detail__c>> mapCateg,
                                 map<id, Category_Rule_Entity_Detail__c> mapEntity,String categType,
                                String dataSetId, Integer blockSeq,
                                map<String,Category_Derived_Variable_Metadata__c> mapMetaData)
    {
        BRWrapBlock block = new BRWrapBlock();
        list<BRWrapBlock.WrapGroup> lstGroup = new list<BRWrapBlock.WrapGroup>();        
        list<BROutputCriteria> lstOutputCri = new list<BROutputCriteria>(); 
        
        Category_Rule_Entity_Detail__c blockEntityDet = mapEntity.get(blockId);
        block.criteriaLogic= blockEntityDet.display_expression__c;
        block.executionLogic= blockEntityDet.Exec_Expression__c;        
        Integer grpSeq=0;
        for(Id grpId : mapGrp.get(blockId)){   // 2 groups     
            Category_Rule_Entity_Detail__c EntityDet= mapEntity.get(grpId);  //1st grp             
            BRWrapBlock.WrapGroup grp= CreateGroup(grpId,mapRuleCri,dataSetId,blockSeq, grpSeq);         
            if(EntityDet != null && EntityDet.Logic_Operator__c != '')
                grp.selGroupOp = EntityDet.Logic_Operator__c;        
            lstGroup.add(grp);
            grpSeq++;
        }        
        if(categType!='Else'){
            for(Category_Rule_Output_Detail__c categ : mapCateg.get(blockId)){
                Category_Derived_Variable_Metadata__c metaInfo = mapMetaData.get(categ.Derived__c);
                BROutputCriteria cri= CreateCriteria(categ,metaInfo);
                lstOutputCri.add(cri);
            }
            block.lstOutputCriteria=lstOutputCri;
        }       
        
        block.lstWrapGroup = lstGroup;
        return block;
    }
    
    public static BRWrapBlock.WrapGroup CreateGroup(Id grpId,map<id,list<Category_Rule_Criteria_Detail__c>> mapRuleCri,
                                 String dataSetId, Integer blockSeq, Integer grpSeq)                                 
    {
        BRWrapBlock.WrapGroup grp = new BRWrapBlock.WrapGroup();
        List<BRWrapCriteria> lstCriteria = new List<BRWrapCriteria>();
        if(mapRuleCri.get(grpId) != null){
            Integer criSeq=0;
            for(Category_Rule_Criteria_Detail__c criDetail : mapRuleCri.get(grpId)){
                BRWrapCriteria cri = CreateCriteria(criDetail,dataSetId, blockSeq, grpSeq, criSeq);
                lstCriteria.add(cri);
                criSeq++;
            }
            grp.lstwrapCriteria = lstCriteria; 
        }       
        
        return grp;
    }
    
    public static BRWrapCriteria CreateCriteria(Category_Rule_Criteria_Detail__c criDetail, 
                                       String dataSetId,Integer blockSeq,Integer grpSeq,Integer criSeq)
    {  
        list<Data_Set_Column_Detail__c> lstColumns=getColumnsData(dataSetId);
        map<string, string> mapCols = new map<string, string>();
        for(Data_Set_Column_Detail__c col : lstColumns){
            mapCols.put(col.tb_col_nm__c,col.variable_type__c);
        }
        BRWrapCriteria cri = new BRWrapCriteria();    
        List<BRWrapBlock.DataSetColumnDetails> dtSetColDetails=new List<BRWrapBlock.DataSetColumnDetails>();
        for(Data_Set_Column_Detail__c cols:lstColumns){
            dtSetColDetails.add(new BRWrapBlock.DataSetColumnDetails(cols.ds_col_name__c,cols.datatype__c,cols.tb_col_nm__c,cols.variable_type__c));
        }
        
        //wrapCriteria.fieldName = lstColumns;   
        cri.fieldName= dtSetColDetails;   
        //cri.fieldName=lstColumns;             
        
        cri.opVal = getOperators(criDetail.FieldDataType__c);        
        cri.selFieldName=criSeq+'@'+grpSeq+'@'+blockSeq+'@'+criDetail.FieldDataType__c+'@'+criDetail.Field__c+'@'+mapCols.get(criDetail.Field__c);                    
        cri.selOpVal=criSeq+'@'+grpSeq+'@'+blockSeq+'@'+criDetail.Criteria_operator__c; //equal - not equal
        if(criDetail.Logic_Operator__c == null || criDetail.Logic_Operator__c == '' || criDetail.Logic_Operator__c == '-'){
            criDetail.Logic_Operator__c='-';
            cri.criNameOptions=new string[] {'-'};  
        }
        else
            cri.criNameOptions=new string[] {'AND','OR'};  
        cri.criName=criDetail.Logic_Operator__c;
        cri.seqNo=Integer.valueOf(criDetail.Sequence__c);
        cri.fieldVal=criDetail.Param_value__c;
        return cri;
    }
    @AuraEnabled
    public static BRWrapBlock AddNewBlock(String outputCategory, String DataSetId){
        List<BROutputCriteria> lstCriteria = new List<BROutputCriteria>();
        if(outputCategory != '')
            lstCriteria = (List<BROutputCriteria>)JSON.deserialize(outputCategory, List<BROutputCriteria>.class);        
        BRWrapBlock wrapBlock = AddBlock(true,lstCriteria,DataSetId);                
        return wrapBlock;
    }
    public static BRRuleDetails FillRuleDetails(String scenarioInstanceId,BRRuleDetails obj){
        String scenarioId= CPGUtility.GetScenarioId(scenarioInstanceId);
        set<Id> rankBusinessId = new set<Id>();
        map<Id,String> mapBusinessMaster = new map<Id,String>();
        list<business_rule_type_master__c> lstRuleType = [select id, name,Component_Type__r.name
                                                          from business_rule_type_master__c
                                                          where Component_Type__r.name
                                                          in ('Call Balancing','Aggregation','Derived Field')];
        
        list<business_rule_type_master__c> lstRulesCall = new list<business_rule_type_master__c>();
        for(business_rule_type_master__c ruleMaster : lstRuleType){
            if(ruleMaster.Component_Type__r.name == 'Call Balancing'){
                lstRulesCall.add(ruleMaster);
            }
            else if(ruleMaster.Component_Type__r.name =='Aggregation'){                
                mapBusinessMaster.put(ruleMaster.id, ruleMaster.Component_Type__r.name);  
            }
           else if(ruleMaster.Component_Type__r.name =='Derived Field' && ruleMaster.name=='Rank'){
                mapBusinessMaster.put(ruleMaster.id, ruleMaster.name); 
            }
        }
        list<Business_rules__c> lstRules = [select id, aggregate_level__c,Business_Rule_Type_Master__c,
                                            ScenarioRuleInstanceDetails__c
                                            from Business_rules__c
                                            where Business_Rule_Type_Master__c in: mapBusinessMaster.keySet() 
                                            and Scenario__c=: scenarioId];
        list<string> lstLevels = new list<string>();
        for(Business_rules__c rule : lstRules){
            String componentName = mapBusinessMaster.get(rule.Business_Rule_Type_Master__c);
            if(componentName =='Aggregation'){
                lstLevels.add(rule.aggregate_level__c);
            }
            else if (componentName =='Rank'){
                rankBusinessId.add(rule.id);
            }
        }
        list<string> lstCustPriority= new list<string>();
        for(Business_Rule_FieldMap_Details__c lstOutPutFields : [select id,Param_Name__c 
                                                                 from Business_Rule_FieldMap_Details__c
                                                                 where IO_Flag__c='O'
                                                                 and Business_Rule__c in: rankBusinessId])
        {
            lstCustPriority.add(lstOutPutFields.Param_Name__c);
        }
        obj.ruleName='';
        obj.ruleType = lstRulesCall;
        obj.selRuleType = lstRulesCall[0].Name;
        obj.level = lstLevels;
        if(lstLevels!=null && lstLevels.size()>0){
            obj.selLevel = lstLevels[0];
        }
        obj.custPrior=lstCustPriority;
        if(lstCustPriority!=null && lstCustPriority.size()>0){
            obj.selCustPrior = lstCustPriority[0];
        }
        return obj; 
    }
    @AuraEnabled
    public static BRRuleDetails GetRuleDetails(String scenarioInstanceId){
        BRRuleDetails obj = new BRRuleDetails();
        obj = FillRuleDetails(scenarioInstanceId,obj);       
        return obj;        
    }

    @AuraEnabled
    public static BRWrapBlock.WrapGroup AddAGroup(String DataSetId) {  
        lstColumns=getColumnsData(DataSetId);
        BRWrapBlock.WrapGroup grp=AddGroup(true,lstColumns);        
        return grp;
    }

    @AuraEnabled
    public static BRWrapCriteria AddCriteria(String DataSetId){ 
        lstColumns=getColumnsData(DataSetId);
        BRWrapCriteria wrapCriteria = AddaCriteria(false,lstColumns);        
        return wrapCriteria;
    }
    @AuraEnabled
    public static BRWrapBlock.WrapGroup AddNestedGrp(String DataSetId){ 
        lstColumns=getColumnsData(DataSetId);
        BRWrapBlock.WrapGroup grp=AddGroup(true,lstColumns);        
        return grp;
    }
}